import java.awt.Dimension;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.geom.Line2D;
import java.awt.geom.Point2D;
import java.lang.*;
import java.util.ArrayList;
import java.util.Arrays;

//--------------------------------------------------------------------//
/**
 * {mC}f[^f
 */
public class VoronoiModel{

/** {mC}Ehl[\ */
  public static final int VORONOI=1;

/** KuGOt\ */
  public static final int GABRIEL=3;

/** ΋ߖTOt\ */
  public static final int REL_NE=4;

/** ŋߖTOt\ */
  public static final int NEAREST=6;

/** ŏS؂\ */
  public static final int MS_TREE=7;

/** KuGOt̃rbg */
  public static final int GABRIEL_BIT=4;

/** ΋ߖTOt̃rbg */
  public static final int REL_NE_BIT=8;

/** ŋߖTOt̏rbg */
  public static final int NEAREST_BIT1=16;

/** ŋߖTOt̋trbg */
  public static final int NEAREST_BIT2=32;

/** ŏS؂̃rbg */
  public static final int MS_TREE_BIT=64;

/** _̕`攼a */
  protected static final int POINT_R=2;

/** _̕`撼a */
  protected static final int POINT_D=2*POINT_R;

/** _̕`攼a2 */
  protected static final int POINT_R2=POINT_R*POINT_R;

/** _̃Xg */
  protected ArrayList points;

/** hl[ӂ̃Xg */
  protected ArrayList edges;

/**
 * {mC}f[^f\z
 */
  public VoronoiModel(){
    points=new ArrayList();
    edges=new ArrayList();
  }

//--------------------------------------------------------------------//
/**
 * _ǉ
 * @param newPoint Vǉ_
 */
  public void addPoint(Point newPoint){
    if((newPoint.x<0) || (newPoint.y<0)) return;
    int pointCount=points.size();
    for(int i=0;i<pointCount;i++){
      Point p=(Point)points.get(i);
      if((int)p.distanceSq(newPoint)<=POINT_R2){
      	return;                         // dȂ_͉Ȃ
      }
    }
    points.add(new Point(newPoint));
  }

//--------------------------------------------------------------------//
/**
 * _
 */
  public void clearPoint(){
    points.clear();
  }

//--------------------------------------------------------------------//
/**
 * {mC}Ehl[쐬
 * @param size ʃTCY
 */
  public void create(Dimension size){
    edges.clear();
    int pointCount=points.size();
    for(int i=0;i<pointCount-1;i++){
      Point p1=(Point)points.get(i);
      for(int j=i+1;j<pointCount;j++){
      	Point p2=(Point)points.get(j);
      	Line2D line1=linePoint(size,p1,p2);
      	double dxba=line1.getX2()-line1.getX1();
      	double dyba=line1.getY2()-line1.getY1();
      	boolean intsw=true;
      	for(int k=0;k<pointCount;k++){
      	  if((k!=i) && (k!=j) && intsw){
      	    Point p3=(Point)points.get(k);
      	    Line2D line2=linePoint(size,p1,p3);
      	    double dx21=line2.getX2()-line2.getX1();
      	    double dy21=line2.getY2()-line2.getY1();
      	    double sw1=dy21*(line2.getX2()-line1.getX1())
      	      	      -dx21*(line2.getY2()-line1.getY1());
      	    double sw2=dy21*dxba-dx21*dyba;
// słȂꍇ
      	    if(Math.abs(sw2)>Double.MIN_VALUE){
      	      double sw3=dx21*(p1.getY()-line2.getY1())
      	      	      	-dy21*(p1.getX()-line2.getX1());
      	      double sw4=sw3*(dx21*(line1.getY1()-line2.getY1())
      	      	      	-dy21*(line1.getX1()-line2.getX1()));
      	      double sw5=sw3*(dx21*(line1.getY2()-line2.getY1())
      	      	      	-dy21*(line1.getX2()-line2.getX1()));
      	      sw1/=sw2;
      	      double xt=line1.getX1()+sw1*dxba;
      	      double yt=line1.getY1()+sw1*dyba;
// I_ύX
      	      if((sw4>0.0) && (sw5<0.0)){
      	      	line1.setLine(line1.getX1(),line1.getY1(),xt,yt);
      	      }
// n_ύX
      	      else if((sw4<0.0) && (sw5>0.0)){
      	      	line1.setLine(xt,yt,line1.getX2(),line1.getY2());
      	      }
// {mCӂ
      	      else if((sw4<0.0) && (sw5<0.0)){
      	      	intsw=false;
      	      }
      	    }
      	  }
      	}
      	Point2D lp1=line1.getP1();
      	Point2D lp2=line1.getP2();
// {mC_̒_̋mF
      	for(int k=0;k<pointCount;k++){
      	  if((k!=i) && (k!=j) && intsw){
      	    Point p3=(Point)points.get(k);
      	    int sw1=(int)(p3.distanceSq(lp1)-p1.distanceSq(lp1));
      	    int sw2=(int)(p3.distanceSq(lp2)-p1.distanceSq(lp2));
      	    if((sw1<0) || (sw2<0)) intsw=false;
      	  }
        }
// {mCӁEhl[ӂ
      	if(intsw){
      	  edges.add(new Edge(i,j,lp1,lp2));
        }
      }
    }
  }

//--------------------------------------------------------------------//
/**
 * 2Ԃ
 * @param size ʃTCY
 * @param p1 ̓_ 1
 * @param p2 ̓_ 2
 * @return 2\ <code>Line2D</code>
 */
  public Line2D linePoint(Dimension size,Point p1,Point p2){
    int dx=p1.x-p2.x;
    int dy=p1.y-p2.y;
    double xm=0.5*(double)(p1.x+p2.x);
    double ym=0.5*(double)(p1.y+p2.y);
    return linePoint(size.width,size.height,xm,ym,dy,-dx);
  }

//--------------------------------------------------------------------//
/**
 * [Ԃ
 * @param width ʕ
 * @param height ʍ
 * @param x ʉ߂_ <i>x</i> W
 * @param y ʉ߂_ <i>y</i> W
 * @param dx xNg <i>x</i> 
 * @param dy xNg <i>y</i> 
 * @return \ <code>Line2D</code>
 */
  public Line2D linePoint(int width,int height,double x,double y,
      	      	      	  int dx,int dy){
    double outfl=10.0;
    double ymin=-outfl*(double)height;
    double ymax=(outfl+1.0)*(double)height;

// 
    if(dx==0){
      return new Line2D.Double(x,ymin,x,ymax);
    }
// ̑̏ꍇ
    else{
      double coef=(double)dy/(double)dx;
      double x1=-outfl*(double)width;
      double y1=coef*(x1-x)+y;
      double x2=(outfl+1.0)*(double)width;
      double y2=coef*(x2-x)+y;
      if(y1<ymin){
      	x1=(ymin-y)/coef+x;
      	y1=ymin;
      }
      else if(y1>ymax){
      	x1=(ymax-y)/coef+x;
      	y1=ymax;
      }
      if(y2<ymin){
      	x2=(ymin-y)/coef+x;
      	y2=ymin;
      }
      else if(y2>ymax){
      	x2=(ymax-y)/coef+x;
      	y2=ymax;
      }
      return new Line2D.Double(x1,y1,x2,y2);
    }
  }

//--------------------------------------------------------------------//
/**
 * KuGOt쐬
 */
  public void createGabrielGraph(){
    int edgeCount=edges.size();
    for(int i=0;i<edgeCount;i++){
      Edge edge=(Edge)edges.get(i);
      Point2D v1=edge.getVoronoiPoint1();
      Point2D v2=edge.getVoronoiPoint2();
      int x1=(int)v1.getX();
      int y1=(int)v1.getY();
      int dx=(int)v2.getX()-x1;
      int dy=(int)v2.getY()-y1;
      Point sp=edge.getStartVertex(points);
      Point ep=edge.getEndVertex(points);
      int f1=(ep.y-sp.y)*(ep.x-x1)-(ep.x-sp.x)*(ep.y-y1);
      int f2=dx*(ep.y-y1)-dy*(ep.x-x1);
      int f3=dx*(ep.y-sp.y)-dy*(ep.x-sp.x);

// {mCӂƃhl[ӂꍇ
      if(((f1>0) && (f2>0) && (f3>f1) && (f3>f2))
      || ((f1<0) && (f2<0) && (f3<f1) && (f3<f2))){
      	edge.addCode(GABRIEL_BIT);
      }
    }
  }

//--------------------------------------------------------------------//
/**
 * ΋ߖTOt쐬
 */
  public void createRelNeGraph(){
    int pointCount=points.size();
    int edgeCount=edges.size();
    for(int i=0;i<edgeCount;i++){
      Edge edge=(Edge)edges.get(i);
      Point sp=edge.getStartVertex(points);
      Point ep=edge.getEndVertex(points);
      edge.addCode(REL_NE_BIT);
      int dist=(int)sp.distanceSq(ep);
      boolean sw=true;
      for(int j=0;j<pointCount;j++){
      	if((j!=edge.getStartVertex())
      	&& (j!=edge.getEndVertex()) && sw){
      	  Point p=(Point)points.get(j);
      	  int dlarge=(int)Math.max(p.distanceSq(sp),p.distanceSq(ep));
      	  if(dlarge<dist){
      	    edge.addCode(-REL_NE_BIT);
      	    sw=false;
      	  }
      	}
      }
    }
  }

//--------------------------------------------------------------------//
/**
 * ŋߖTOt쐬
 */
  public void createNearestGraph(){
    int pointCount=points.size();
    int edgeCount=edges.size();
    for(int i=0;i<pointCount;i++){
      boolean sw=true;
      Point p1=(Point)points.get(i);
      int distMin=Integer.MAX_VALUE;
      int nearestVertex=0;
// ŋߖT_T
      for(int j=0;j<pointCount;j++){
      	if(j!=i){
      	  int dist=(int)p1.distanceSq((Point)points.get(j));
      	  if(dist<distMin){
      	    distMin=dist;
      	    nearestVertex=j;
      	  }
      	}
      }
      for(int j=0;j<edgeCount;j++){
      	Edge edge=(Edge)edges.get(j);
// 
      	if((edge.getStartVertex()==i)
      	&& (edge.getEndVertex()==nearestVertex)){
      	  edge.addCode(NEAREST_BIT1);
      	}
// t
      	else if((edge.getStartVertex()==nearestVertex)
      	     && (edge.getEndVertex()==i)){
      	  edge.addCode(NEAREST_BIT2);
      	}
      }
    }
  }

//--------------------------------------------------------------------//
/**
 * ŏS؂쐬
 */
  public void createMinimumSpanTree(){
    int pointCount=points.size();
    int edgeCount=edges.size();

    int length[]=new int[edgeCount];
    for(int i=0;i<edgeCount;i++){
      Edge edge=(Edge)edges.get(i);
      Point sp=edge.getStartVertex(points);
      Point ep=edge.getEndVertex(points);
      length[i]=(int)sp.distanceSq(ep);
    }
// hl[ӂZɕבւ
    int list[]=HeapSort.sortedList(edgeCount,length);
    int cycle[]=new int[pointCount];
    int nextVertex[]=new int[pointCount];
    int cycleSize[]=new int[pointCount];
    for(int i=0;i<pointCount;i++){
      cycle[i]=i;
      nextVertex[i]=i;
    }
    Arrays.fill(cycleSize,1);

    int numberOfMSEdge=0;
    int vertex1,vertex2;
    for(int i=0;i<edgeCount;i++){
      if(numberOfMSEdge>=pointCount-1) return;
      Edge edge=(Edge)edges.get(list[i]);
      int startVertex=edge.getStartVertex();
      int endVertex=edge.getEndVertex();
// TCNȂꍇ
      if(cycle[startVertex]!=cycle[endVertex]){
      	numberOfMSEdge++;
      	edge.addCode(MS_TREE_BIT);
      	if(cycleSize[cycle[startVertex]]>cycleSize[cycle[endVertex]]){
      	  vertex1=startVertex;
      	  vertex2=endVertex;
      	}
      	else{
      	  vertex1=endVertex;
      	  vertex2=startVertex;
      	}
      	int cycle1=cycle[vertex1];
      	int cycle2=cycle[vertex2];
      	cycleSize[cycle1]+=cycleSize[cycle2];
      	int vertex=vertex2;
      	do{
      	  cycle[vertex]=cycle1;
      	  vertex=nextVertex[vertex];
      	}while(vertex!=vertex2);
      	vertex=nextVertex[vertex1];
      	nextVertex[vertex1]=nextVertex[vertex2];
      	nextVertex[vertex2]=vertex;
      }
    }
  }

//--------------------------------------------------------------------//
/**
 * _`悷
 * @param g `悷OtBbNXReLXg
 */
  public void drawPoint(Graphics2D g){
    int pointCount=points.size();
    for(int i=0;i<pointCount;i++){
      Point p=(Point)points.get(i);
      g.fillOval(p.x-POINT_R,p.y-POINT_R,POINT_D,POINT_D);
    }
  }

//--------------------------------------------------------------------//
/**
 * hl[}`悷
 * @param g `悷OtBbNXReLXg
 * @param mark `悷}
 */
  public void drawDiagrams(Graphics2D g,int mark){
    int bit1=(int)Math.pow(2,mark);
    int bit2=bit1/2;
    if(mark==NEAREST) bit2/=2;

    int edgeCount=edges.size();
    for(int i=0;i<edgeCount;i++){
      Edge edge=(Edge)edges.get(i);
// ̐}``悷
      if(edge.isDraw(bit1,bit2)){
      	Point sp=edge.getStartVertex(points);
      	Point ep=edge.getEndVertex(points);
      	g.drawLine(sp.x,sp.y,ep.x,ep.y);
      }
    }
  }

//--------------------------------------------------------------------//
/**
 * {mC}`悷
 * @param g `悷OtBbNXReLXg
 */
  public void drawVoronoi(Graphics2D g){
    int edgeCount=edges.size();
    for(int i=0;i<edgeCount;i++){
      Edge edge=(Edge)edges.get(i);
      g.draw(edge.getVoronoiEdge());
    }
  }
}
