import java.awt.Canvas;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.image.VolatileImage;
import java.lang.*;

//--------------------------------------------------------------------//
/**
 * \LoX
 */
public class VoronoiViewCanvas extends Canvas implements MouseListener{

/** _ҏW[h\ */
  public static final int EDIT_MODE=1;

/** }`惂[h\ */
  public static final int DIAGRAM_MODE=2;

/** {mC}f[^f */
  protected VoronoiModel model;

/** `惂[h */
  protected int drawMode;

/** `悷}`̎ */
  protected int drawType;

/** }`vZXCb` vZς݂Ȃ true */
  protected boolean calculated;

/** plTCY */
  protected Dimension panelSize;

/** }EXʒu\ <code>Point</code> */
  protected Point mouse;

/** _uobt@OpC[W */
  protected VolatileImage bgImage;

/** _uobt@OpC[W̃OtBbNXReLXg */
  protected Graphics2D bg;

/** wiF */
  protected Color bgColor;

/** _\F */
  protected Color pointColor;

/** e}\F */
  protected Color diagramColor;

/** {mC}\F */
  protected Color voronoiColor;

/**
 * \LoX\z
 * @param model {mC}f[^f
 */
  public VoronoiViewCanvas(VoronoiModel model){
    this.model=model;
    mouse=new Point(-1,-1);
    drawType=VoronoiModel.VORONOI;
    drawMode=EDIT_MODE;
    calculated=false;
    bgColor=Color.WHITE;
    pointColor=Color.BLACK;
    diagramColor=Color.RED;
    voronoiColor=Color.BLUE;
    addMouseListener(this);
    setBackground(bgColor);
  }

//--------------------------------------------------------------------//
/**
 * }EX{^̏s
 * @param e }EXANVƂCxg
 */
  public void mousePressed(MouseEvent e){
    if(drawMode==EDIT_MODE){
      mouse.setLocation(e.getX(),e.getY());
      model.addPoint(mouse);
      repaint();
    }
  }

//--------------------------------------------------------------------//
/**
 * }EX{^𗣂̏s
 * @param e }EXANVƂCxg
 */
  public void mouseReleased(MouseEvent e){
  }

//--------------------------------------------------------------------//
/**
 * }EXNbN̏s
 * @param e }EXANVƂCxg
 */
  public void mouseClicked(MouseEvent e){
  }

//--------------------------------------------------------------------//
/**
 * }EXR|[lgɓ̏s
 * @param e }EXANVƂCxg
 */
  public void mouseEntered(MouseEvent e){
  }

//--------------------------------------------------------------------//
/**
 * }EXR|[lgȍs
 * @param e }EXANVƂCxg
 */
  public void mouseExited(MouseEvent e){
  }

//--------------------------------------------------------------------//
/**
 * }w肵ĕ`悷
 */
  public void setDrawType(int drawtype){
    this.drawType=drawtype;
    repaint();
  }

//--------------------------------------------------------------------//
/**
 * }
 */
  public void drawVD(){
    if(!calculated){
      model.create(panelSize);
      model.createGabrielGraph();
      model.createRelNeGraph();
      model.createNearestGraph();
      model.createMinimumSpanTree();
      calculated=true;
    }
    drawMode=DIAGRAM_MODE;
    repaint();
  }

//--------------------------------------------------------------------//
/**
 * _
 */
  public void clear(){
    mouse.setLocation(-1,-1);
    model.clearPoint();
    calculated=false;
    drawMode=EDIT_MODE;
    repaint();
  }

//--------------------------------------------------------------------//
/**
 * ĕ`悷
 * @param g `悷OtBbNXReLXg
 */
  public void update(Graphics g){
    paintModel(bg);
    g.drawImage(bgImage,0,0,this);
  }

//--------------------------------------------------------------------//
/**
 * `悷
 * @param g `悷OtBbNXReLXg
 */
  public void paint(Graphics g){
    setPaint();
    paintModel(bg);
    g.drawImage(bgImage,0,0,this);
  }

//--------------------------------------------------------------------//
/**
 * ʂݒ肷
 */
  protected void setPaint(){
    panelSize=getSize();
    bgImage=createVolatileImage(panelSize.width,panelSize.height);
    bg=bgImage.createGraphics();
  }

//--------------------------------------------------------------------//
/**
 * {mC}`悷
 * @param g `悷OtBbNXReLXg
 */
  protected void paintModel(Graphics2D g){
    g.setColor(bgColor);
    g.fillRect(0,0,panelSize.width,panelSize.height);
    if(drawMode==DIAGRAM_MODE){
      g.setColor(diagramColor);
      model.drawDiagrams(g,drawType);
      if(drawType==VoronoiModel.VORONOI){
      	g.setColor(voronoiColor);
      	model.drawVoronoi(g);
      }
    }
    g.setColor(pointColor);
    model.drawPoint(g);
  }
}
